/* Copyright (c) 2019 Synology Inc. All rights reserved. */

var async=require("async"),dns=require("dns"),log4js=require("log4js"),request=require("request"),transform=require("stream").Transform,url=require("url"),zlib=require("zlib"),auth=require("./lib/common/auth.js"),db=require("./lib/common/db.js"),parser=require("./lib/common/parser.js"),portalHttpServer=require("./lib/http/portalHttpServer.js"),ruleMgr=require("./lib/common/ruleManager.js"),sessionArrayMgr=require("./lib/common/sessionArrayMgr.js"),sitesReader=require("./lib/common/sitesReader.js"),
socketServer=require("./lib/common/socketServer.js"),tc=require("./lib/common/tc.js"),https=require("https");global._config=require("./config.js");global._log=log4js.getLogger();global._q=require("q");global._utils=require("./lib/common/utils");var execSync=_utils.execSync,sessionArray=[],SOL_SOCKET=1,SO_OPT=0,GC_SIZE=26214400,GC_INTERVAL=36E5,transDataSize=0,connectionTimeout=3E5;
function main(){var a;log4js.configure("/var/packages/VPNPlusServer/target/synorouterportal/log.conf");socketServer.createSocketServer(socketCmdHandler);process.on("uncaughtException",function(b){_log.error(b,"uncaughtException")});process.on("SIGUSR2",function(){_log.info("regenerate session ticket keys due to SIGUSR2...");a.regenerateTicketKey()});process.on("SIGTERM",function(){socketServer.closeSocketServer();0===sessionArray.length&&process.exit();sessionArray.forEach(function(b){tc.removeTcMark(b.user,
b.sessionID);db.updateConnectWPDB(b.target,b.sessionID).then(function(){return db.updateConnectDB(b.user,b.sessionID)})})});ruleMgr.init();_config.loadVPNPlusConfig();a=portalHttpServer.createServer(serverHandler);portalHttpServer.httpsServer.on("connection",connectionEventHandler);setInterval(function(){sessionArray=sessionArrayMgr.kickOfflineUser(sessionArray)},5E3);setInterval(function(){_log.info("i do gc every hour");global.gc()},GC_INTERVAL);a.listen(function(){_log.info("server started")})}
function connectionEventHandler(a){a.stored_remotePort=a.remotePort;a.once("close",function(){a.stored_remotePort&&sessionArray.forEach(function(b){var c=_utils.isArrayObjExist(b.oriPort,a.stored_remotePort);-1!==c&&b.oriPort.splice(c,1)})})}
function constructRelay(a,b,c){var g,e=c.destObj,h=c.entry,f=0,j=new transform,k=false,l=[],m=undefined,o=307;a=parser.parseRequestForTarget(a);a.headers=parser.parseRequestHeaderForTarget(a.headers);e={url:e.scheme+"://"+e.host+(80===e.port||443===e.port?"":":"+e.port)+a.url,headers:a.headers,method:a.method,rejectUnauthorized:false,followAllRedirects:true,forever:true};delete e.headers.host;_log.info("request to: "+e.url);g=request(e).on("error",function(d){_log.error(d)}).on("redirect",function(){if(this.response.headers.hasOwnProperty("set-cookie"))m=
this.response.headers["set-cookie"];if(this.response.statusCode)o=this.response.statusCode}).on("response",function(d){d=d.socket;if(d._handle&&d._handle.fd){var i=d._handle.fd;if(!(-1!==_utils.isArrayObjExist(c.tc.upload.fd,i)||-1===i)){d.setMaxListeners(0);c.tc.upload.fd.push(i);tc.setTcMark(i,SOL_SOCKET,SO_OPT,c.tc.upload.mark);d.once("close",function(){var p=_utils.isArrayObjExist(c.tc.upload.fd,i);-1!==p&&c.tc.upload.fd.splice(p,1)})}}});a.pipe(g).on("response",function(d){var i=d.headers;d.setTimeout(0);
if(d.httpVersion==="1.0"){b.useChunkedEncodingByDefault=false;delete i.connection}delete i["transfer-encoding"];"strict-transport-security"in i&&delete i["strict-transport-security"];if(a.url!==d.request.uri.path){d.statusCode=o;i.location=url.resolve("https://"+h+"."+_config.getDomain()+":"+_config.getHttpsPort(),d.request.uri.path)}if(m){i["set-cookie"]=m;m=undefined}i=parser.parseResHeaderForClient(i);c.destObj.scheme=d.request.uri.protocol.toString().replace(":","");c.destObj.host=d.request.uri.hostname;
c.destObj.port=parseInt(d.request.uri.port);var p=i["content-type"];j._transform=function(n,q,s){n=n.toString("binary");sitesReader.updateTitle(n,p,h);sitesReader.updateFavicon(n,a.headers["user-agent"],h,c.destObj);n=parser.parseResDataForClient(n);if(_config.getEnableMixContent())k=detectMixContent(n)||k;n=new Buffer(n,"binary");l.push(n);s(null)};j.on("finish",function(){var n=_utils.getCookiesFromHeader(a.headers).mixContent,q=Buffer.concat(l);if(k&&(!n||0!==a.url.indexOf(n)))_utils.showHtmlPage("mixContent.html",
b,{Location:i.location});else{i["content-length"]=q.length;b.writeHead(d.statusCode,i);b.write(q);b.end()}});var r=d.headers["content-encoding"];if(p)if(p.indexOf("text/html")>=0||p.indexOf("application/javascript")>=0||p.indexOf("application/json")>=0)if(r)if(0<=r.indexOf("gzip")){delete i["content-encoding"];delete i["content-length"];d.pipe(zlib.createGunzip()).pipe(j)}else{_log.error("we did not support the encoding: "+r);d.pipe(j)}else d.pipe(j);else{b.writeHead(d.statusCode,i);d.pipe(b)}else{b.writeHead(d.statusCode,
i);d.pipe(b)}d.on("data",function(n){c.expireTime=Date.now()+connectionTimeout;f+=n.length;if(GC_SIZE<f){_log.info("garbage collection started due to heap size is full");global.gc();f=0}});d.on("error",function(n){_log.error(n,"proxy response error");b.destroy.bind(b)})});if(a.socket._handle&&a.socket._handle.fd){if(-1!==_utils.isArrayObjExist(c.tc.download.fd,a.socket._handle.fd))return;a.socket.setMaxListeners(0);a.socket.stored_fd=a.socket._handle.fd;c.tc.download.fd.push(a.socket._handle.fd);
tc.setTcMark(a.socket._handle.fd,SOL_SOCKET,SO_OPT,c.tc.download.mark);a.socket.once("close",function(){if(a.socket.stored_fd){var d=_utils.isArrayObjExist(c.tc.download.fd,a.socket.stored_fd);-1!==d&&c.tc.download.fd.splice(d,1)}})}g.once("error",function(d){_log.error(d,"proxy request error");g.removeAllListeners();a.removeAllListeners()});a.once("error",function(){g.destroy.bind(g)});g.once("finish",function(){g.destroy.bind(g)});b.once("finish",function(){b.destroy.bind(b);transDataSize+=b.transferBytes;
if(GC_SIZE<transDataSize){_log.info("garbage collection started due to response finish");global.gc();transDataSize=0}});b.once("close",function(){_log.info("close");g.abort()})}
function constructWsRelay(a,b,c){var g,e=0;a=parser.parseRequestForTarget(a);a.headers=parser.parseRequestHeaderForTarget(a.headers);g={headers:a.headers,host:c.destObj.host,port:c.destObj.port,path:a.url,method:a.method,rejectUnauthorized:false,followAllRedirects:true,forever:true};delete g.headers.host;_log.info("request websocket to: "+g.host,"path is: "+a.url);https.request(g).on("error",function(h){_log.error(h);a.removeAllListeners()}).on("upgrade",function(h,f){var j=h.headers,k="HTTP/"+h.httpVersion+
" "+h.statusCode+" "+h.statusMessage+"\r\n";k+=j.connection?"Connection: "+j.connection+"\r\n":"";k+=h.headers["sec-websocket-accept"]?"Sec-WebSocket-Accept: "+h.headers["sec-websocket-accept"]+"\r\n":"";k+=h.headers["sec-websocket-extensions"]?"Sec-WebSocket-Extensions: "+h.headers["sec-websocket-extensions"]+"\r\n":"";k+=h.headers["sec-websocket-key"]?"Sec-WebSocket-Key: "+h.headers["sec-websocket-key"]+"\r\n":"";k+=h.headers["sec-websocket-protocol"]?"Sec-WebSocket-Protocol: "+h.headers["sec-websocket-protocol"]+
"\r\n":"";k+=h.headers["sec-websocket-version"]?"Sec-WebSocket-Version: "+h.headers["sec-websocket-version"]+"\r\n":"";k+="Server: "+j.server+"\r\n";k+="Upgrade: "+j.upgrade+"\r\n";k+="\r\n";b.write(k);f.pipe(b);b.pipe(f);var l=f._handle.fd;if(!(-1!==_utils.isArrayObjExist(c.tc.upload.fd,l)||-1===l)){f.setMaxListeners(0);c.tc.upload.fd.push(l);tc.setTcMark(l,SOL_SOCKET,SO_OPT,c.tc.upload.mark);f.once("close",function(){var m=_utils.isArrayObjExist(c.tc.upload.fd,l);-1!==m&&c.tc.upload.fd.splice(m,
1)});f.on("data",function(m){c.expireTime=Date.now()+connectionTimeout;e+=m.length;if(GC_SIZE<e){_log.info("garbage collection started due to heap size is full");global.gc();e=0}})}}).end();if(a.socket._handle&&a.socket._handle.fd){if(-1!==_utils.isArrayObjExist(c.tc.download.fd,a.socket._handle.fd))return;a.socket.setMaxListeners(0);a.socket.stored_fd=a.socket._handle.fd;c.tc.download.fd.push(a.socket._handle.fd);tc.setTcMark(a.socket._handle.fd,SOL_SOCKET,SO_OPT,c.tc.download.mark);a.socket.once("close",
function(){if(a.socket.stored_fd){var h=_utils.isArrayObjExist(c.tc.download.fd,a.socket.stored_fd);-1!==h&&c.tc.download.fd.splice(h,1)}})}a.once("error",function(){realReq.destroy.bind(realReq)});b.once("finish",function(){b.destroy.bind(b);transDataSize+=b.transferBytes;if(GC_SIZE<transDataSize){_log.info("garbage collection started due to response finish");global.gc();transDataSize=0}})}
function detectMixContent(a){return null!==a.toString().match(/<\s*.*link.*href="http:\/\/.[^"]*.css".*\s*>/)||null!==a.toString().match(/<\s*.*script.*src="http:\/\/.[^"]*".*\s*>/)||null!==a.toString().match(/<\s*.*iframe.*src="http:\/\/.[^"]*".*\s*>/)||null!==a.toString().match(/<\s*.*object.*data="http:\/\/.[^"]*".*\s*>/)}function redirectURL(a,b,c,g){a.writeHead(307,{Location:"https://"+b+(c?":"+c:"")+(g?g:"")});a.end()}
function serverHandler(a,b){var c=a.headers.host.substr(0,a.headers.host.indexOf("."+_config.getDomain())),g=_utils.getCookiesFromHeader(a.headers).vpnplus_id,e=a.connection.remoteAddress,h=a.connection.remotePort;if(c)c===_config.getServicePrefix()?webportalSiteHandler(a,b,c,g,e,h):webvpnHandler(a,b,c,g,e,h);else{_log.info("307 redirect to login page");redirectURL(b,_config.getServicePrefix()+"."+_config.getDomain(),_config.getHttpsPort(),a.url)}}
function initCheckPrivOpt(a,b){a.headers["X-FORWARDED-FOR"]=b.replace("::ffff:","");a={url:_utils.webportalUrl+"/webportal.cgi?action=check_priv_and_quota",headers:a.headers,method:a.method,rejectUnauthorized:false,followAllRedirects:true};delete a.headers.host;delete a.headers["accept-encoding"];return a}
function webportalSiteHandler(a,b,c,g,e,h){var f;if(g)if(0!==a.url.indexOf("/webportal.cgi?go=")){_log.info("webportal UI page's request");getWebportalSite(a,b,e)}else{f=initCheckPrivOpt(a,e);request(f,function(j,k,l){if(j||200!==k.statusCode){_log.error("check privilege failed: "+j+" "+k.statusCode);getWebportalSite(a,b,e)}else{var m;l=JSON.parse(l);if(l.uid){m=goHandler(a,b,l.uid,l.name,g,e,h);if(l.hasPermission){_log.info("session id is valid");db.insertConnectDB(l.name,g,e,l.uid).then(function(){return _q.all([db.insertConnectWPDB(m.target,
g,l.uid),db.updateHistoryDB(l.uid,m.entry,m.target)])});m.permission?_utils.showHtmlPage("loading.html",b,null,function(o){return o=o.replace("TARGET","https://"+m.entry+"."+_config.getDomain()+":"+_config.getHttpsPort()+m.destObj.path)}):_utils.showHtmlPage("pageNotFound.html",b)}else if("license"===l.reason){_log.error("no license quota");db.updateHistoryDB(l.uid,m.entry,m.target);_utils.showHtmlPage("noLicenseQuota.html",b)}else{_log.error("no permission of using webportal. uid is: "+m.uid);db.updateHistoryDB(m.uid,
m.entry,m.target);redirectPath=c&&destObj?"/webportal.cgi?go="+destObj.scheme+"://"+destObj.host+":"+destObj.port+a.url:a.url;redirectURL(b,_config.getServicePrefix()+"."+_config.getDomain(),_config.getHttpsPort(),redirectPath)}}else{_log.error("i dont know who is using the web portal.");getWebportalSite(a,b,e)}}})}else{_log.info("there is no session id exist");getWebportalSite(a,b,e)}}
function webvpnHandler(a,b,c,g,e,h){var f=ruleMgr.getMapping(c),j,k,l;if(g)if(k=updateSessionArray(g,e,h,c)){a.headers["X-FORWARDED-FOR"]=e.replace("::ffff:","");getTargetSite(a,b,k)}else if(f)if(c!==f.prefix){_log.info("redirect to correct path");j="/webportal.cgi?go="+f.scheme+"://"+f.host+":"+f.port+f.path;redirectURL(b,_config.getServicePrefix()+"."+_config.getDomain(),_config.getHttpsPort(),j)}else{k=initCheckPrivOpt(a,e);request(k,function(m,o,d){if(m||200!==o.statusCode){_log.error("check privilege failed: "+
m+" "+o.statusCode);getWebportalSite(a,b,e)}else{var i;d=JSON.parse(d);if(d.uid)if(l=auth.getCustomSite(d.uid,c)){i=genNewSessionObj(d.uid,d.name,g,c,e,h,f);i.permission=l;sessionArray.push(i);ruleMgr.insertDynamicRule(f);if(d.hasPermission){_log.info("session id is valid");db.insertConnectDB(d.name,g,e,d.uid).then(function(){return _q.all([db.insertConnectWPDB(i.target,g,d.uid),db.updateHistoryDB(d.uid,i.entry,i.target)])});i.permission?getTargetSite(a,b,i):_utils.showHtmlPage("pageNotFound.html",
b)}else if("license"===d.reason){_log.error("no license quota");db.updateHistoryDB(d.uid,i.entry,i.target);_utils.showHtmlPage("noLicenseQuota.html",b)}else{_log.error("no permission of using webportal. uid is: "+i.uid);db.updateHistoryDB(i.uid,i.entry,i.target);j=c&&f?"/webportal.cgi?go="+f.scheme+"://"+f.host+":"+f.port+a.url:a.url;redirectURL(b,_config.getServicePrefix()+"."+_config.getDomain(),_config.getHttpsPort(),j)}}else{_log.error("no permission of accessing site: "+c+", uid is: "+d.uid);
redirectURL(b,_config.getServicePrefix()+"."+_config.getDomain(),_config.getHttpsPort(),"/views/pageNotFound.html")}else{_log.error("i dont know who is using the web portal.");j=c&&f?"/webportal.cgi?go="+f.scheme+"://"+f.host+":"+f.port+a.url:a.url;redirectURL(b,_config.getServicePrefix()+"."+_config.getDomain(),_config.getHttpsPort(),j)}}})}else{_log.error("no permission of accessing website");redirectURL(b,_config.getServicePrefix()+"."+_config.getDomain(),_config.getHttpsPort(),"/views/pageNotFound.html")}else{_log.info("there is no session id exist");
j=c&&f?"/webportal.cgi?go="+f.scheme+"://"+f.host+":"+f.port+a.url:a.url;redirectURL(b,_config.getServicePrefix()+"."+_config.getDomain(),_config.getHttpsPort(),j)}}
function genNewSessionObj(a,b,c,g,e,h,f){a={sessionID:c,uid:a,oriIP:e,oriPort:[h],entry:g,user:b,expireTime:Date.now()+connectionTimeout};if(f){c=tc.getTcMarkByUser(b,c);SO_OPT=c[0];a.tc={upload:{mark:c[1],fd:[]},download:{mark:c[2],fd:[]}};a.blockSites=tc.getBlockList(b);a.destObj=f;a.target=f.scheme+"://"+f.host+":"+f.port+f.path}else a.target=_utils.webportalUrl+"/";return a}
function getWebportalSite(a,b,c){a.headers["X-FORWARDED-FOR"]=c.replace("::ffff:","");a.pipe(request({url:_utils.webportalUrl+a.url,headers:a.headers,method:a.method,rejectUnauthorized:false})).pipe(b)}
function getTargetSite(a,b,c){dns.lookup(c.destObj.host,4,function(g,e){if(g){_log.error("dns resolve failed: "+c.destObj.host);redirectURL(b,_config.getServicePrefix()+"."+_config.getDomain(),_config.getHttpsPort(),"/views/pageNotFound.html")}else if(_utils.isSiteBlocked(e,c)){_log.info("request url is blocked by admin");redirectURL(b,_config.getServicePrefix()+"."+_config.getDomain(),_config.getHttpsPort(),"/views/pageNotFound.html")}else"upgrade"===a.headers.connection.toLowerCase()?constructWsRelay(a,
b,c):constructRelay(a,b,c)})}
function goHandler(a,b,c,g,e,h,f){b={};a=a.url.replace("/webportal.cgi?go=","");var j=url.parse(a),k={},l;b.scheme=j.protocol?j.protocol.replace(":",""):"http";b={scheme:b.scheme,host:j.hostname,port:j.port?parseInt(j.port):"http"===b.scheme?80:443,path:j.path};if(k=ruleMgr.getRulesOfTarget()[b.scheme+"://"+b.host+":"+b.port+b.path]||ruleMgr.getRulesOfTarget()[b.scheme+"://"+b.host+":"+b.port+"/"]){j=k.entry;l=auth.getCustomSite(c,k.alias)}else{j=_utils.genRandomEntry(b.scheme+"://"+b.host+":"+b.port);
l=auth.getDefault(c)}b.prefix=j;if(l){(k=updateSessionArray(e,h,f,j))||(k=genNewSessionObj(c,g,e,j,h,f,b));k.destObj=b;k.permission=l;sessionArray.push(k);ruleMgr.insertDynamicRule(b)}else{_log.error("no permission of user: "+c);k={entry:j,target:a,permission:l}}return k}
function updateSessionArray(a,b,c,g){var e=sessionArray.find(function(h){return h.sessionID===a&&h.oriIP===b&&h.entry===g});if(e){e.oriPort.find(function(h){return h===c})||e.oriPort.push(c);e.expireTime=Date.now()+connectionTimeout}return e}
function socketCmdHandler(a,b){var c;c=JSON.parse(a).cmd;a=JSON.parse(a).option;switch(c){case "reload_rule":_log.info("reload rule");_config.loadVPNPlusConfig();ruleMgr.reloadStaticRule(sessionArray);b.end();break;case "reload_blockSites":_log.info("reload block sites");sessionArray.forEach(function(g){g.blockSites=tc.getBlockList(g.user)});b.end();break;case "rebuild_tc":_log.info("rebuild tc");tc.rebuildTcMark(sessionArray,SOL_SOCKET,SO_OPT);b.end();break;case "get_tc_mark":_log.info("get tc mark");
c=tc.checkCurrentTcMark(sessionArray,SOL_SOCKET,SO_OPT);b.end(c,"utf8");break;case "logout":_log.info(a+" logout");sessionArray=sessionArrayMgr.logoutHandler(sessionArray,a);b.end();break;default:_log.error("no such command: "+c);b.end("failed","utf8");break}}main();
